package com.kilometer0.SWFAddressSignalsRobotLegs
{
	import com.kilometer0.SWFAddressSignalsRobotLegs.controller.ApplicationStartupCommand;
	import com.kilometer0.SWFAddressSignalsRobotLegs.controller.ChangeApplicationStateCommand;
	import com.kilometer0.SWFAddressSignalsRobotLegs.model.ApplicationModel;
	import com.kilometer0.SWFAddressSignalsRobotLegs.model.ViewStateModel;
	import com.kilometer0.SWFAddressSignalsRobotLegs.signals.ModifyApplicationState;
	import com.kilometer0.SWFAddressSignalsRobotLegs.signals.ViewStateChanged;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.FirstView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.MainUI;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.SecondView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.ThirdView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.mediators.FirstViewMediator;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.mediators.MainUIMediator;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.mediators.SecondViewMediator;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.mediators.ThirdViewMediator;
	import com.kilometer0.swfaddress.SWFAddress;
	
	import flash.display.DisplayObjectContainer;
	
	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.mvcs.SignalContext;
	
	public class MainContext extends SignalContext
	{
		public function MainContext(contextView:DisplayObjectContainer)
		{
			super(contextView);
		}
		
		override public function startup():void
        {
        	injector.mapSingleton(SWFAddress);
        	
        	/* Models */
        	injector.mapSingleton(ApplicationModel);
        	injector.mapSingleton(ViewStateModel);
        	
        	injector.mapSingleton(ViewStateChanged);
        	
        	commandMap.mapEvent(ContextEvent.STARTUP_COMPLETE,ApplicationStartupCommand, ContextEvent,true);
        	
        	signalCommandMap.mapSignalClass(ModifyApplicationState, ChangeApplicationStateCommand);
        	
        	mediatorMap.mapView(MainUI, MainUIMediator);
        	mediatorMap.mapView(FirstView, FirstViewMediator);
        	mediatorMap.mapView(SecondView, SecondViewMediator);
        	mediatorMap.mapView(ThirdView, ThirdViewMediator);
        	
        	super.startup();
        }

	}
}