package com.kilometer0.SWFAddressSignalsRobotLegs.view.mediators
{
	import com.kilometer0.SWFAddressSignalsRobotLegs.model.ViewStateModel;
	import com.kilometer0.SWFAddressSignalsRobotLegs.signals.ViewStateChanged;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.FirstView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.IView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.MainUI;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.SecondView;
	import com.kilometer0.SWFAddressSignalsRobotLegs.view.ThirdView;
	import com.kilometer0.swfaddress.SWFAddress;
	
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;
	
	import org.osflash.signals.Signal;
	import org.osflash.signals.natives.NativeSignal;
	import org.robotlegs.mvcs.Mediator;

	public class MainUIMediator extends Mediator
	{
		[Inject]
		public var view:MainUI;
		
		[Inject]
		public var viewStateChanged:ViewStateChanged;
		
		[Inject]
		public var viewState:ViewStateModel;
		
		[Inject]
		public var swfAddress:SWFAddress;
		
		protected var views:Object;
		
		protected var currentView:IView;
		
		public function MainUIMediator()
		{
			super();
		}

		override public function onRegister():void
		{
			viewStateChanged.add(onViewStateChange);
			
			view.main();
			
			views = {};
			views[""] = FirstView;
			views["view2"] = SecondView;
			views["view3"] = ThirdView;
			
			var ns:NativeSignal = new NativeSignal(view.logo,MouseEvent.CLICK,MouseEvent);
			ns.add(gotoHome);
			
		}
		
		protected function gotoHome(myEvent:MouseEvent):void
		{	
			trace("GotoHome");
			swfAddress.setValue("/");
			
		}
		protected function onViewStateChange():void
		{
			var viewName:String = viewState.viewName;
			trace("onViewStateChanged: "+viewName);
			
			if(views.hasOwnProperty(viewName))
			{
				if(views[viewName] is Class)
				{
					views[viewName] = new views[viewName];
				}
				
				if(currentView != null)
				{
					var s:Signal = new Signal();
					s.addOnce(function():void { view.viewContainer.removeChildAt(0); showView(views[viewName]);});
					currentView.hide(s);
				}
				else
				{
					showView(views[viewName]);
				}
			}
		}
		
		protected function showView(newView:IView):void
		{
			currentView = newView;
			view.viewContainer.addChild(DisplayObject(currentView));
			currentView.show(null);
		}
	}
}